org.apache.commons.ssl.asn1

## Class DERObjectIdentifier

- java.lang.Object
- - org.apache.commons.ssl.asn1.ASN1Encodable
  - - org.apache.commons.ssl.asn1.DERObject
    - - org.apache.commons.ssl.asn1.ASN1Object
      - - org.apache.commons.ssl.asn1.DERObjectIdentifier

All Implemented Interfaces:
  DEREncodable, DERTags

    public class DERObjectIdentifier
    extends ASN1Object

### Field Summary

Fields
`(package private) java.lang.String` `identifier`

### Fields inherited from class org.apache.commons.ssl.asn1.ASN1Encodable

`BER, DER`

### Fields inherited from interface org.apache.commons.ssl.asn1.DERTags

`APPLICATION, BIT_STRING, BMP_STRING, BOOLEAN, CONSTRUCTED, ENUMERATED, EXTERNAL, GENERAL_STRING, GENERALIZED_TIME, GRAPHIC_STRING, IA5_STRING, INTEGER, NULL, NUMERIC_STRING, OBJECT_IDENTIFIER, OCTET_STRING, PRINTABLE_STRING, SEQUENCE, SEQUENCE_OF, SET, SET_OF, T61_STRING, TAGGED, UNIVERSAL_STRING, UTC_TIME, UTF8_STRING, VIDEOTEX_STRING, VISIBLE_STRING`

### Constructor Summary

Constructors
Constructor and Description
`DERObjectIdentifier(byte[] bytes)`
`DERObjectIdentifier(java.lang.String identifier)`

### Method Summary

Methods
`(package private) boolean` `asn1Equals(DERObject o)`
`(package private) void` `encode(DEROutputStream out)`
`java.lang.String` `getId()`
`static DERObjectIdentifier` `getInstance(ASN1TaggedObject obj, boolean explicit)` return an Object Identifier from a tagged object.
`static DERObjectIdentifier` `getInstance(java.lang.Object obj)` return an OID from the passed in object
`int` `hashCode()`
`private static boolean` `isValidIdentifier(java.lang.String identifier)`
`java.lang.String` `toString()`
`private void` `writeField(java.io.OutputStream out, java.math.BigInteger fieldValue)`
`private void` `writeField(java.io.OutputStream out, long fieldValue)`

### Methods inherited from class org.apache.commons.ssl.asn1.ASN1Object

`equals, fromByteArray`

### Methods inherited from class org.apache.commons.ssl.asn1.DERObject

`toASN1Object`

### Methods inherited from class org.apache.commons.ssl.asn1.ASN1Encodable

`getDEREncoded, getDERObject, getEncoded, getEncoded`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Field Detail

#### identifier

    java.lang.String identifier

### Constructor Detail

#### DERObjectIdentifier

    DERObjectIdentifier(byte[] bytes)

#### DERObjectIdentifier

    public DERObjectIdentifier(java.lang.String identifier)

### Method Detail

#### getInstance

    public static DERObjectIdentifier getInstance(java.lang.Object obj)

return an OID from the passed in object

Throws:
  `java.lang.IllegalArgumentException` - if the object cannot be converted.

#### getInstance

    public static DERObjectIdentifier getInstance(ASN1TaggedObject obj,
                                  boolean explicit)

return an Object Identifier from a tagged object.

Parameters:
  `obj` - the tagged object holding the object we want
  `explicit` - true if the object is meant to be explicitly tagged false otherwise.
Throws:
  `java.lang.IllegalArgumentException` - if the tagged object cannot be converted.

#### getId

    public java.lang.String getId()

#### writeField

    private void writeField(java.io.OutputStream out,
                  long fieldValue)
                     throws java.io.IOException

Throws:
  `java.io.IOException`

#### writeField

    private void writeField(java.io.OutputStream out,
                  java.math.BigInteger fieldValue)
                     throws java.io.IOException

Throws:
  `java.io.IOException`

#### encode

    void encode(DEROutputStream out)
          throws java.io.IOException

Specified by:
  `encode` in class `ASN1Object`
Throws:
  `java.io.IOException`

#### hashCode

    public int hashCode()

Specified by:
  `hashCode` in class `ASN1Object`

#### asn1Equals

    boolean asn1Equals(DERObject o)

Specified by:
  `asn1Equals` in class `ASN1Object`

#### toString

    public java.lang.String toString()

Overrides:
  `toString` in class `java.lang.Object`

#### isValidIdentifier

    private static boolean isValidIdentifier(java.lang.String identifier)